"""TODO fill in description"""

# AUTOGENERATED! DO NOT EDIT! File to edit: ../../nbs/api/03_complib/00_exec_component.ipynb.

# %% ../../nbs/api/03_complib/00_exec_component.ipynb 4
from __future__ import annotations
import asyncio
from abc import abstractmethod

import fbdev
from ..comp.packet import Packet
from ..comp.port import PortType, PortSpec, PortSpecCollection
from ..comp.base_component import BaseComponent

# %% auto 0
__all__ = ['ExecComponent']

# %% ../../nbs/api/03_complib/00_exec_component.ipynb 6
class ExecComponent(BaseComponent):
    execute_after_start = True
    
    port_specs = PortSpecCollection(
        PortSpec(PortType.SIGNAL, 'execute')
    )
    
    def __init__(self):
        super().__init__()
        self._main_task: asyncio.Task = None
    
    async def _post_start(self):
        self._task_manager.create_task(self._pre_execute())
        if self.execute_after_start:
            self._task_manager.create_task(
                self.put_packet((PortType.SIGNAL, 'execute'), Packet.get_empty())
            )
        self._main_task = self._task_manager.create_task(self._pre_execute())
    
    async def _pre_execute(self):
        await self._await_signal('execute')
        await self._update_config()
        await self._execute()
        self._main_task = self._task_manager.create_task(self._pre_execute())
    
    @abstractmethod
    async def _execute(self):
        raise NotImplementedError()
