"""TODO fill in description"""

# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/api/exceptions.ipynb.

# %% auto 0
__all__ = ['FBRuntimeError', 'EdgeError', 'LostPacketError', 'NodeError', 'ComponentError', 'ComponentExecutionError',
           'ComponentBackgroundProcessError']

# %% ../nbs/api/exceptions.ipynb 4
import asyncio

import fbdev

# %% ../nbs/api/exceptions.ipynb 5
class FBRuntimeError(RuntimeError):
    """Errors raised from within the fbdev runtime (as opposed to from within the user-defined
    logic inside components.) Always subclass, do not raise directly."""
    def __init__(self, message:str=""):
        super().__init__(message)

# %% ../nbs/api/exceptions.ipynb 6
class EdgeError(FBRuntimeError):
    """Errors raised from within the runtime of an edge."""
    def __init__(self, message:str=""):
        super().__init__(message)

# %% ../nbs/api/exceptions.ipynb 7
class LostPacketError(RuntimeError):
    def __init__(self, packet, message:str=""):
        super().__init__(message)
        self._packet = packet

# %% ../nbs/api/exceptions.ipynb 8
class NodeError(RuntimeError):
    """Errors raised from within the runtime of a node."""
    def __init__(self, message:str=""):
        super().__init__(message)

# %% ../nbs/api/exceptions.ipynb 9
class ComponentError(RuntimeError):
    """Errors raised from within the runtime of a component (as opposed to from within the flow logic).
    Always subclass, do not raise directly."""
    def __init__(self, message:str=""):
        super().__init__(message)

# %% ../nbs/api/exceptions.ipynb 10
class ComponentExecutionError(ComponentError):
    pass

# %% ../nbs/api/exceptions.ipynb 11
class ComponentBackgroundProcessError(ComponentError):
    pass
